try:
    from cStringIO import StringIO
except ImportError:
    from StringIO import StringIO

class HornetInstaller:
    def __init__(self, context):
        self.context = context
        self.out = StringIO()

    def setup_all(self):
        """
            Performs all setup steps
        """
        print >> self.out, "Setting up Hornet"
        self.setup_types()
        self.setup_skins()

    def setup_types(self):
        """
            Sets up `Hornet Mount Point`, `Hornet Folder`, and `Hornet Record`
            in portal_types
        """
        print >> self.out, "Setting up Types"
        tt = self.context.portal_types

        def registerType(type_name):
            tt.manage_addTypeInformation(typeinfo_name=type_name,
                                         add_meta_type='Factory-based Type Information')



        # TODO: Use a central registry of 'Hornet' types?
        types = ("Hornet Mount Point", "Hornet Folder", "Hornet Record")

        nav_props = self.context.portal_properties.navtree_properties
        dontlist  = list( nav_props.metaTypesNotToList        )
        dontquery = list( nav_props.parentMetaTypesNotToQuery )
        
        for type in types:
            print >> self.out, "* " + type
            try:registerType("Hornet: " + type)            
            except Exception, e: print '! %s' % e
                
            dontlist.append( type )
            dontquery.append( type )
        
        nav_props.metaTypesNotToList = dontlist
        nav_props.parentMetaTypesNotToQuery = dontquery
        


    def setup_skins(self):
        """
            Sets up all hornet skin layers in portal_skins
        """
        print >> self.out, "Registering Skins"
        st = self.context.portal_skins

        #skin = 'skinpath_' + st.getDefaultSkin()
        skin = st.getDefaultSkin()

        def registerSkin(path):
            st.manage_addProduct['CMFCore'].manage_addDirectoryView(path)
            layers = st.getSkinPath(skin)
            if not layers:
                raise 'skin not found'
            layers = [layer.strip() for layer in layers.split(',')]
            if layerName not in layers:
                try:
                    layers.insert(layers.index('custom')+1, layerName)
                except ValueError:
                    layers.append(layerName)
                layers = ','.join(layers)
                st.addSkinSelection(skin, layers)



        for layerName in ['Hornet','HornetWidgets','HornetSchema']:
            print >> self.out, "* %s" % layerName
            registerSkin('Hornet/skins/%s' % layerName)





def install(self):
    """ Installes Hornet into the specified portal context """

    installer = HornetInstaller(context=self)
    installer.setup_all()

    return installer.out.getvalue()



#TODO: uninstall