# SQLSchema - Rough prototype of a schema system.
# Needs a lot of work.




##################################################
#                                                #
#            THIS FILE IS DEPRECATED             #
#                                                #
#       use Hornet.Schema.Widgets instead        #
#                                                #
##################################################



print "WARNING: import of deprecated module Hornet.SQLSchema; use Hornet.Schema.Widgets instead"













from Products.Archetypes.public import *     
from cStringIO import StringIO
from ExtensionClass import Base
from AccessControl import ClassSecurityInfo
from Globals import InitializeClass
from Acquisition import Implicit
from CallbackIterator import CallbackIterator

class SQLWidget(Implicit):
    security = ClassSecurityInfo()                
    security.setDefaultAccess('allow')
        
    # ZPT Macro to use (translates to here/widget/text/macros/[edit|view]
    widget = 'widget_text'
    
    def macro(self, mode='edit'):
        return getattr(self, self.widget).macros[mode] 
    
    def __init__(self, key, **kwargs):
        self.key    = key
        self.kwargs = kwargs
        
    def Label(self):
        label = self.getArg('label', self.key )
        
        try:
            field_translation = self.i18n_translate( label )
        except KeyError:
            try:field_translation = self.i18n_translate( self.key )
            except KeyError:
                field_translation = label
        except AttributeError:
            return label
        return field_translation
            
    
    def Help(self):
        return self.getArg('help')
        
    def Description(self):
        desc = self.getArg('desc') or self.getArg('description') 
        try:return self.i18n_translate(desc)
        except KeyError:
            return desc
        
        
    def Name(self):
        return self.key
    
    def getCssClass(self):
        return self.getArg('css_class')
    
    def getArg(self, key, default=''):
        try:
            return self.kwargs[key]
        except KeyError:
            return default 
         
    def getWidgetValue(self, datasource=None):
        value = self.get( self.key, '' )
        if value is None: value = ''
        return value
        
    def get(self, key, default=None, datasource=None):
        if not datasource:
            datasource = self
            
        return getattr( datasource, key, default )

    def Vocabulary(self, datasource=None):
        vocab = self.getArg('vocabulary',{}) or self.getArg('vocab', {})
        if type( vocab ) is str:
                vocab = self.get(vocab, datasource=datasource)()
                    
        if hasattr(vocab, 'items'): vocab = vocab.items()
                
        for option in vocab:
            
            if type(option) is str:
                key = value = option
            else:
                try:key, value = option
                except: key = value = option
                
            try:value = self.i18n_translate(value)
            except KeyError:
                pass
            
            yield key, value        
        
            
class VisualClear(SQLWidget):
    security = ClassSecurityInfo()                
    security.setDefaultAccess('allow')
    
    widget = "widget_visualclear"
            
    
class Label(SQLWidget):
    security = ClassSecurityInfo()                
    security.setDefaultAccess('allow')        
    
    widget = "widget_label"
    
class CustomWidget(SQLWidget):
    security = ClassSecurityInfo()                
    security.setDefaultAccess('allow')        
    
    def macro(self, mode='edit'):
        return self.getArg(mode) 
                
class StringWidget(SQLWidget):
    security = ClassSecurityInfo()                
    security.setDefaultAccess('allow')        
        
    widget = "widget_string"
    

class JSCalendarWidget(SQLWidget): 
    security = ClassSecurityInfo()                
    security.setDefaultAccess('allow')        
        
    widget = "widget_jscalendar" 

     
class TextWidget(SQLWidget):
    security = ClassSecurityInfo()                
    security.setDefaultAccess('allow')        
        
    def render(self, datasource=None):
        return """
            <textarea name="%s" id="widget-%s">%s</textarea>
        """ % ( self.key, self.key, self.getWidgetValue(datasource))
           
        

class SelectionWidget(SQLWidget):
        security = ClassSecurityInfo()                
        security.setDefaultAccess('allow')
        
        widget = 'widget_select'
        
            
class MultiCheckboxWidget(SQLWidget): 
        security = ClassSecurityInfo()                
        security.setDefaultAccess('allow')
        
        widget="widget_multiCheckbox"
        
class CheckboxWidget(SQLWidget): 
        security = ClassSecurityInfo()                
        security.setDefaultAccess('allow')
        
        widget="widget_checkbox"
        
InitializeClass(CheckboxWidget)

        
                        
class FieldSet(SQLWidget):
    security = ClassSecurityInfo()
    security.setDefaultAccess('allow')
                                
    def __init__(self, key, title=None, widgets=None, **kwargs):
        self.key     = key
        self.title   = title
        self.widgets = widgets
        self.kwargs  = kwargs
        
    def Label(self):
        label = self.getArg('label')
	try:return self.i18n_translate(label)
	except:return label
	
        
    def getWidgets(self):
        return self.widgets
    
    def iterator(self):
        for widget in self.getWidgets():
            yield widget.__of__(self)
        #return CallbackIterator(self.getWidgets(), lambda x: x.__of__(self))
            
        
                
class SQLSchema(Base, Implicit):
    """
        Simple Widget Schema
    """                
    security = ClassSecurityInfo()                
    security.setDefaultAccess('allow')
                 
    def __init__(self, fieldsets, i18n=None):
        self.fieldsets = fieldsets
        self.i18n=i18n
        
    def getLanguage(self):
        accept = self.REQUEST['HTTP_ACCEPT_LANGUAGE'].split(',')
        for language in accept:
            options = language.split(';')
            code = options[0]
            return code
            
        
    def i18n_translate(self, string, language=None):
        if not hasattr(self.i18n, '__call__'):
            return string
    
        return self.i18n(string, language)
        
    def mapTo(self, datasource, filter=None):
        for fieldset in self.getFieldsets(filter):
            yield fieldset.__of__(self.__of__(datasource))
        
    def getFieldsets(self, filter=None):
        """ getFields """
        if not filter: return self.fieldsets
        if filter:
            filtered = []
            for fieldset in self.fieldsets:
                if fieldset.Name() in filter:
                    filtered.append(fieldset)
                    
            return filtered

    
    def allFieldNames(self):
        """ Returns a list of field names, in order """
        for fieldset in self.getFieldsets():
            for widget in fieldset.getWidgets():
                yield widget.Name()
                
    def allFieldLabels(self):
        r = []
        for fieldset in self.getFieldsets():
            for widget in fieldset.getWidgets():
                r.append( (widget.Name(), widget.Label()) )
        return r


            
#### Experimental
class Group:
    security = ClassSecurityInfo()                
    security.setDefaultAccess('allow')
    def __init__(self, id, title, children=(), fieldsets=(), **kw):
        self.id = id
        self.title = title
        self.children = children
        self.fieldsets = fieldsets
        self.kwargs = kw
    
    def getArg(self, key, default=None):
        return self.kwargs.get(key, default)
    
    def find(self, key):
        if self.id == key: return self
        for child in self.getChildren():
            found = child.find(key)
            if found: return found
    
class Page(Group):
    security = ClassSecurityInfo()                
    security.setDefaultAccess('allow')
        
    
class PageGroup(Group):
    security = ClassSecurityInfo()                
    security.setDefaultAccess('allow')
            
InitializeClass(Group)
InitializeClass(Page)
InitializeClass(PageGroup) 
            
            
                    
InitializeClass(SQLSchema) 
InitializeClass(Label) 
InitializeClass(StringWidget)
InitializeClass(TextWidget)
InitializeClass(SelectionWidget)
InitializeClass(MultiCheckboxWidget)
InitializeClass(FieldSet)
InitializeClass(VisualClear)
InitializeClass(JSCalendarWidget)
