from AccessControl import ClassSecurityInfo
from Globals import InitializeClass

_marker='_marker'

class DisplayList:
    
    security = ClassSecurityInfo()                
    security.setDefaultAccess('allow')
    
    
    def keys( self ):
        return self.orderedKeys[:]
        
    
    def values( self ):
        return [ self[key] for key in self.orderedKeys ]
    
    def items( self ):
        return [ ( key, self[key] ) for key in self.orderedKeys ]

    
    def __getitem__( self, key ):
        
        return self.byKey[ key ]
    
    def get( self, key, default=_marker ):
        if default is _marker:
            return self.byKey.get( key )
        else:
            return self.byKey.get( key, default )
    
    def byKey( self, key, default=None ):
        return self.get( key, default )
    
    def byValue( self, value, default=None ):
        return self.byValue.get( value, default )
    
    def __init__(self, vocab):
        
                    
        if hasattr(vocab, 'items'): vocab = vocab.items()
    
        byKey = {}
        byVal = {}
        orderedKeys = [] 
       
        for option in vocab:
            
            if hasattr(option,'keys') and len(option.keys()) == 2 \
               and 'key' in option and 'value' in option:
                key   = option['key']
                value = option['value']
            
            elif type(option) is str:
                key = value = option
            else:
                try:key, value = option
                except: key = value = option
                
            
            byKey[key]   = value
            byVal[value] = key
            orderedKeys.append( key )
            
        self.byKey = byKey
        self.orderedKeys = orderedKeys
        self.byVal = byVal
        
        
InitializeClass( DisplayList )