class BaseSchema:

    def generateRuleset( self, filter=None ):
        ''' Generates a rule set from the specified schema '''
        
        rules = {} 
        
        for fieldset in self.getFieldsets(filter):                        
            condition = fieldset.getArg('condition')
            if condition:
                rules['fieldset-' + fieldset.Name()] = [fieldset.getArg('condition')]            
            
            for field in fieldset.getWidgets():
                condition = field.getArg('condition')
                if condition:
                    rules['field-' + field.Name()] = [field.getArg('condition')]
                
        return rules
     