from AccessControl import ClassSecurityInfo
from Globals import InitializeClass
from BaseWidget import BaseWidget
from DateTime.DateTime import DateTime, DateTimeError

class DateWidget(BaseWidget):
    security = ClassSecurityInfo()                
    security.setDefaultAccess('allow')        
        
    widget = "widget_date"
    
    def getDateValue(self):
        try:
            return DateTime( self.getWidgetValue() ) 
        except DateTimeError:
            return None 
    
    def getYears(self):
        now = DateTime()
        return self.getArg('years') or range( now.year(), now.year() + 10 )
    
    def getMonths(self):
        return (
            (1,  "January"),
            (2,  "February"),
            (3,  "March"),
            (4,  "April"),
            (5,  "May"),
            (6,  "June"),
            (7,  "July"),
            (8,  "August"),
            (9,  "September"),
            (10, "October"),
            (11, "November"),
            (12, "December"),
        )
        
    def preprocess( self, form ):
        try:
            name  = self.Name()
            year  = form[name + "_year"]
            month = form[name + "_month"]
            day   = form[name + "_day"]
        
            value = None
            if year and month and day:
                value = "%s-%s-%s" % ( year, month, day )
            
            
            
            form[name] = value
        except KeyError:
            return        
        
InitializeClass(DateWidget)     