from AccessControl import ClassSecurityInfo
from Globals import InitializeClass
from BaseWidget import BaseWidget

from Products.Hornet.Schema.Resolvers import Lazy 

    
class FileWidget(BaseWidget):
    security = ClassSecurityInfo()                
    security.setDefaultAccess('allow')        
        
    widget = "widget_file"
     
    def preprocess( self, form ):
        """ Save the uploaded file """
        
        handler_name = self.getArg('handler')
        if not handler_name:
            return
            
        handler = getattr( self, handler_name, None )
        if not handler:
            raise AttributeError, 'Could not find upload handler %s' % handler_name
            
        file = form[ self.Name() ]
        handler( file, widget=self, form=form )             
            
    def getWidgetValue( self ):
        reader = self.getArg('reader',None)  
        
        if not reader: return None
        
        if type(reader) is str:
            reader = Lazy(reader)
        
        value = reader(self)
            
        return value() 
        
            
        
        
    
        
InitializeClass(FileWidget)     