#####################################################################
#
#  Hornet SQL Bridge (C) 2005 Mooball.com pty ltd
#  A Zope product to mount an SQL Database into the ZODB
#
#  License: ZPL http://www.zope.org/Resources/ZPL
#  Contact: hornet@mooball.com
#
#  Please see http://plone.org/products/hornet
#
#  *WARNING: This product is ALPHA code. Do not expect it to work.*
#
#####################################################################

#####################################################################
#
#    Hornet Init
#    Author: James Davies (hornet@mooball.com)
#
#    Initializes the root hornet module
#
#####################################################################

# TODO: This module needs cleaning up

#setup icons in ZMI
from ImageFile import ImageFile
misc_={
    'hornetmountpoint_icon.gif' : ImageFile('skins/Hornet/hornetmountpoint_icon.gif',globals()),
    'hornetfolder_icon.gif' :     ImageFile('skins/Hornet/hornetfolder_icon.gif',globals()),
    'hornetrecord_icon.gif' :     ImageFile('skins/Hornet/hornetrecord_icon.gif',globals()),
} 

def importAll(GLOBALS, importClass=False):
    path = GLOBALS['__path__'][0]
    import os
    for file in os.listdir(path):
        if file.startswith('.') or file.startswith('__'): continue
        if os.path.isdir(path + '/' + file):
            module = file
        elif file.endswith('.py'):
            module = file[0:-3]
        else:
            continue

        if importClass:
            exec('from %s import %s' % (module, module), GLOBALS)
        else:
            exec('import %s' % (module), GLOBALS)
        #__import__(module, GLOBALS)


import SQLMountPoint
import HornetFolder

from Products.CMFCore.utils import ContentInit
from Products.CMFCore.CMFCorePermissions import AddPortalContent



#Jdb.connect('/tmp/test.db')

def dummyAdd(**kw):
    """ Dummy Constructor """
    pass

from Products.CMFCore.DirectoryView import registerDirectory
registerDirectory('skins', globals())

#from Products.PythonScripts.Utility import allow_module
from AccessControl import allow_module, ModuleSecurityInfo 

import Schema
from Schema import Widgets
from Schema import Logic
from Schema import Sources
from Schema import DisplayList

#import SQLSchema
#allow_module('Products.Hornet.SQLSchema')

#HACKHACK- need to do this properly... 
allow_module('Products.Hornet.CallbackIterator')
allow_module('Products.Hornet.Schema')
allow_module('Products.Hornet.Schema.Logic.SimpleController')
allow_module('Products.Hornet.Schema.Logic.Node')
allow_module('Products.Hornet.Schema.Widgets')
allow_module('Products.Hornet.Schema.Exceptions')
allow_module('Products.Hornet.Schema.Sources')
allow_module('Products.Hornet.Schema.Sources.PySchema')
allow_module('Products.Hornet.Schema.Logic.SimpleController')
allow_module('Products.Hornet.Schema.Validators')  
allow_module('Products.Hornet.Schema.DisplayList')  
allow_module('Products.Hornet.Schema.Resolvers')

ModuleSecurityInfo('Products.Hornet').declarePublic('Schema')  


# TODO: Cleaner system of registering hornet types (ala Archetypes)

def initialize( context ):
    context.registerClass( SQLMountPoint.SQLMountPoint,   constructors = (SQLMountPoint.manage_addHornetMountPointForm,SQLMountPoint.manage_addHornetMountPoint,))
    #context.registerClass( SQLMountPoint.CMFSQLMountPoint,constructors = (SQLMountPoint.manage_addCMFSQLMountPoint,))

    context.registerClass( HornetFolder.HornetFolder,
                            constructors = (HornetFolder.manage_addHornetFolderForm,
                                            HornetFolder.manage_addHornetFolder
                            ) )

    context.registerClass( HornetFolder.HornetRecord,
                            constructors = (HornetFolder.manage_addHornetRecord,) )


    #context.registerClass( News.NewsFolder,     constructors = (News.manage_addNewsFolder,) )


    types = (
        HornetFolder.HornetRecord,
        HornetFolder.HornetFolder,
        SQLMountPoint.SQLMountPoint,
    )

    constructors = (
        dummyAdd,
        HornetFolder.manage_addHornetFolder,
        SQLMountPoint.manage_addHornetMountPoint,
    )

    ftis = (
        HornetFolder.HornetRecord.factory_type_information,
        HornetFolder.HornetFolder.factory_type_information,
        SQLMountPoint.SQLMountPoint.factory_type_information,
    )

    ContentInit( 'Hornet Content'
             , content_types=types
             , permission=AddPortalContent
             , extra_constructors=constructors
             , fti=ftis
             ).initialize( context )

