##parameters=options
from Products.Hornet.Schema.Logic.SimpleController import traverse, getNamespace
import re

minital = context.minital
    
isManager  = context.REQUEST.AUTHENTICATED_USER.has_permission( 'Manage portal', context )

pages      = options.get('pages', None)
current    = options.get('current', None)
state      = options.get('state', None)
datasource = options.get('datasource',None)

#raise `current.nodePathNames()`

if not pages: 
    return []


def makeUrl( state, name ):
    pairs = []
    for key, value in state.items():
        pairs.append( '%s.%s:record=%s' % (name, key, value) )
        
    return '?' + '&'.join(pairs) 
    
 
def buildStructure( root, myState, forceInactive=False ):
    
    structure = []
    myState = dict( myState ) # make sure we don't modify the original 
    for child in list(root.getChildren()):
        
        #if child.getKey() in current.nodePathNames():
        myState['position'] = child.getKey()
        
        condition = child.getArg('condition')
        if condition:
            result = condition( child, myState, datasource )
            if not result:
                continue 
        
        
        
        url = makeUrl( myState, 'cru_state' )
        
        #url = '?cru_state.position:record=' + child.getKey()
                    
        repeat = child.getArg('repeat')
        if not repeat:
            children = buildStructure( child, myState )
            active = not forceInactive and child.getKey() in current.nodePathNames()
            
            '''
            if child.isLeaf():
                ns = getNamespace( child, myState, datasource )    
                available = ns.get('_available', False) 
            else:
                available = True
            '''
            
            ns = getNamespace( child, myState, datasource )
            available = ns.get('_available', False) 
                
                
            brain = {'title': child.Title(), 
                     'icon': child.getArg('icon', 'document_icon.gif'),
                     'available': available or 0,#isManager,
                     'children': children, 
                     'active': active, 
                     'url': url}
            structure.append( brain )
        else:
            (iterator, sequenceName) = repeat.split(' ')
        
            try:sequence = traverse(datasource, sequenceName)
            except AttributeError:
                continue

            keys = sequence.keys()
            keys.sort()
            
            for key in keys:
                
                value = sequence[ key ]
                
                myState[iterator] = key

                ns = getNamespace( child, myState, datasource )
                
                '''
                if child.isLeaf():
                    available = ns.get( '_available', False ) 
                else:
                    available = True
                '''
                
                available = ns.get( '_available', False ) 
                                    
                
                title = child.Title()
                parsed = minital( title, ns )
                
                brain = {}
                
                
                brain['available'] = available or 0#isManager
                brain['icon']      = child.getArg('icon', 'document_icon.gif')
                brain['title'] = parsed
                
                brain['url'] = makeUrl( myState, 'cru_state' )
                
                #if str(c) == str(state[iterator]): 
                brain['active']   = child.getKey() in current.nodePathNames()\
                                    and state[iterator] == key
                
                brain['children'] = buildStructure( child, myState, forceInactive=not brain['active'] )
                
                structure.append(brain) 
            
        
        
    return structure 
        
        
structure = buildStructure( pages, state )

return structure
    
        
        