var isIE = document.all ? true : false;


function Spreadsheet(name)
{
    var table;
    var tbody;
    var thead;
    var tfoot;
    
    var num_rows=0;
    var blank_row;
    
    var selected_row;
    var selected_column;
    
    var initialized=false;
    
    
    // Maintains a reference to 'this' for callback methods;
    var self = this;
    
    
    function get(name) { return document.getElementById( name ); }
    function createNode(tag,innerHTML)
    {
        var t = document.createElement(tag);
        if(innerHTML) t.innerHTML = innerHTML;
        return t;
    }

    
    this.createNewRow = function()
    {
        // First, clear any callbacks on the current 'blank' row
        if(blank_row){
            var inputs = blank_row.getElementsByTagName('input');
            for(i=0;i<inputs.length;i++){
                inputs[i].onchange=null;
            }
            var th = blank_row.getElementsByTagName('th')[0];
            th.innerHTML = num_rows;
                
        }
        
        // Now construct the new row
        blank_row = createNode('tr');
        blank_row.id = 'blank_row'; 
        var th = createNode('th','*');
        th.onclick = row_clicked;
        blank_row.appendChild(th) 
        for(i=0;i<cols;i++){
            var td = createNode('td');
            var input = createNode('input');
            input.onchange = newRow_changed;
            input.name = this.columnNames[i];
            td.appendChild(input);
            blank_row.appendChild(td);
        }
        tbody.appendChild( blank_row );  
        num_rows++;
    }
    
    this.setEditable = function(columnNames)
    {
        if(columnNames) this.columnNames = columnNames;
        
        if(!initialized)
            return this.flag_editable=true;
        
        cols = this.columnNames.length;
        
        // Iterate over all cells and replace innerHTML with an <input> element
        var cells = table.getElementsByTagName('td');
        for(i=0;i<cells.length;i++)
        {
            if(cells[i].getElementsByTagName('input')[0]) continue;
            var input = createNode('input');
            var cell = cells[i];
            input.value = cell.innerHTML;
            input.name  = this.columnNames[i % num_rows] 
            cell.innerHTML = "";
            cell.appendChild(input)
        }
        
        this.createNewRow();
        
    }
    
    function row_clicked(event)
    {
        if(selected_row)selected_row.className = '';
        if(isIE) target = window.event.srcElement;
        else     target = event.target;
        
        selected_row = target.parentNode;
        selected_row.className = 'selected'

    }    
    
    function table_click(event)
    {
        if(isIE) target = window.event.srcElement;
        else     target = event.target;
        
        if(target.tagName == 'TD' || target.tagName == 'INPUT'){
            if(selected_row) selected_row.className = "";
        }
        
    }
    
    this.enable = function() 
    {
        if(initialized) return;
        initialized=true; 
        table = get(name);
        tbody = table.getElementsByTagName('tbody')[0];
        thead = table.getElementsByTagName('thead')[0];
        tfoot = table.getElementsByTagName('tfoot')[0];
    
        table.onclick = table_click;
        
        table.className='spreadsheet';
        
        function insertTH(row,count){
            var first_cell = row.getElementsByTagName('td')[0]
            if(!first_cell) first_cell = row.getElementsByTagName('th')[0];
            
            var th = createNode('th');
            th.onclick = row_clicked;
            if(count)
                th.innerHTML = count;
            
            row.insertBefore(th, first_cell);
        }
        
        var rows = table.getElementsByTagName('tr');
        num_rows = rows.length - 1;
        for(i=0;i<rows.length;i++)
            if(rows[i] != blank_row)
                insertTH(rows[i],i);
        
        
       if(this.flag_editable)
            this.setEditable();
               

        
    }
    
    
    
    function newRow_changed(event)
    {
        self.createNewRow();
        
    
    }


    
}
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    /***** *********/
    
    
    function initCell(cell)
    {
        function showEditMode()
        {
            var text = cell.innerHTML;
            var input = document.createElement('input');
            input.value = text;
            cell.innerHTML = "";
            cell.appendChild(input);
        }
        
        cell.ondblclick = showEditMode;
    }

    
function OLDinitSpreadsheet(id)
{
    var table = get(id);
    
    function walk(root){
        var children = root.childNodes;
        var i;
        for(i=0;i<children.length;i++){
            walk(children[i]); 
        }

        if( root.tagName == 'TD' && root.parentNode.parentNode.tagName == 'TBODY' ) 
        {
            initCell(root);
        }
               
    }

    walk(table);
}